﻿#target illustrator 
#targetengine main

//ウインドウパネルの設定　ここから
var win = new Window("window","nameChange",[0,0,250,270]); //new Window (type [, title, bounds, {creation_properties}]);[left, top, width,height] 
win.add('panel',[10,20,240,90],'テキスト読込み' ,{borderStyle:"sunken"});//枠線
win.add('statictext',[27,20,80,82],'読込み先：', {preferredSize: [60, 20]});  //テキスト
var select = win.add('button',[85,40,131,60],'選択');   //ボタン
var fileName = win.add('statictext',[27,55,240,100],'※読込なしの場合は、このまま');  //テキスト
var check_02 = win.add('checkbox');//隠しボタン
win.add('panel',[10,100,240,150],'拡張子' ,{borderStyle:"sunken"});//枠線
var radio_01 = win.add('radiobutton',[30,120,80,140],'AI');   //ラジオボタン
var radio_02 = win.add('radiobutton',[100,120,150,140],'PDF');    //ラジオボタン
win.add('panel',[10,160,240,210],'連番' ,{borderStyle:"sunken"});//枠線
var check_01 = win.add('checkbox',[27,181,240,201],'ファイル名に3桁の番号を付ける')　//チェックボタン
var ok = win.add('button',[10,220,115,260],'OK');   //ボタン
var cancel = win.add('button',[120,220,240,260],'キャンセル');   //ボタン
//ウインドウパネルの設定　ここまで

//初期設定　ここから
radio_01.value = true;　//AIにチェック
check_01.value = false; //チェックなし
check_02.value = false; //チェックなし
//初期設定　ここまで

//selectボタン　ここから
select.onClick = function(){
    fileObj = File.openDialog('読み込むファイルを選択してください',callback(),false);   //varを付けないでグローバル変数にする　File.openDialog(タイトル,表示ファイル,複数選択)
    if(fileObj){
        var dest = File.decode(fileObj.name);   //.name：ファイル名の取得　File.decode：文字化けを防ぐ
        fileName.text = "ファイル名：" + dest;   //fileNameを選択したファイル名に置換する
        check_02.value = true; //チェックありにする
     };
};
//selectボタン　ここまで

//cancelボタン　ここから
cancel.onClick = function(){
    win.close();//ウインドウパネルを閉じる
};
//cancelボタン　ここまで

//OKボタン　ここから
ok.onClick = function(){
        //変換するファイルが入っているフォルダを選択　ここから
        var folderObj = Folder.selectDialog("ファイル名を変換するフォルダ"); //フォルダを指定
        if(folderObj){
            var fileList = folderObj.getFiles();//指定されたフォルダに入っているファイルを取得
            //変換するファイルが入っているフォルダを選択　ここから
        
            //ファイル名の変更ここから
            for(var i=0; i < fileList.length; i++){//選択したフォルダに入っているデータの数だけ繰り返す
                if(fileList[i] instanceof File){//サブフォルダを除外してファイルのみ選択
                    var fName = File.decode(fileList[i].name);//ファイル名を取得
                    if(check_02.value === true){//テキストを読みこむ場合
                        for(var n = 0; n < list().length; n++){ //テキスト配列の数だけ繰り返す
                            if(check_01.value === true){//連番をつける場合 
                                fileList[n].rename(serial(n) + "_" + list()[n] + ext()); //ファイル名の変更 
                            }else{
                                fileList[n].rename(list()[n] + ext()); //テキストを読み込んでファイル名の変更 
                            };//if:check_01
                        };//for
                    }else{
                            if(check_01.value === true){//連番をつける場合 
                                fileList[i].rename(serial(i) + "_" + fName + ext());//ファイル名の変更 
                            }else{
                                fileList[i].rename(fName + ext());//ファイル名の変更 
                            };//if:check_01
                    };// if:check_02
                };// instanceof File
            };//for 
          };//if(folderObj)
        //ファイル名の変更ここまで
        
        win.close();//ウインドウパネルを閉じる  
};
//OKボタン　ここまで

//テキストの読み込み　配列作成　ここから
function list(){
        var textObj = [];   //配列を作成
        var myFile = new File(fileObj);    //ファイルオブジェクトのインスタンス（オブジェクトのコピー）を作成
        myFile.encoding = "UTF-8"; // テキストファイルのエンコーディングを指定
        if(myFile.open("r")){   //指定したファイルを読み込む　成功したらｔｒｕｅを返す
            var myText="";  //空変数を作成    
            while(!myFile.eof){//テキストファイルを１行ずつ読み込み最終行まで繰り返す作業
                var myText = myText + myFile.readln() + getLineBreak()  //readin　内容を一行読み込む　
            };   //while 
            var text_array = myText.split(getLineBreak());//split：指定の区切りで文字を分割する    
            for(var i = 0; i < (text_array.length-1); i++){
                textObj.push (text_array[i]);//.push　配列の最後にデータを追加する
            };  //for    
            myFile.close();//ファイルを閉じる   
        };
        return textObj; //　値を返す
};
//テキストの読み込み　配列作成　ここまで

//OS別　改行コード　ここから
function getLineBreak() {
    if ($.os.indexOf("Windows") !== -1) {//osがWindowsなら
        return String.fromCharCode(13);
    } else {
        return "\r";
    };
};
//OS別　改行コード　ここまで

//連番の設定　ここから
function serial(number){
    var prefix =  "000"+ String (number + 1);　　// Stringでファイル数の数値を文字に変換し　”000”に結合する
    prefix = prefix.slice(-3);　//.slice( 開始位置, 終了位置(省略可能) ) 文字を3桁にする
    return prefix;
};
//連番の設定　ここまで

//拡張子の選択　Windows　MAC　両方対応　ここから
function callback() {
    var acceptExtension = [     // 配列　許容するファイル拡張子
        "txt",
        "csv",
    ];
    if (/^win/i.test($.os)) {   //$.os：OSの識別　「/^win/i」は正規表現です。文字列の先頭が「win」で始まるかどうかを判断します。iフラグは大文字小文字を区別しない
        for (var i=0; i < acceptExtension.length; i++) {  //拡張子の数だけ繰り替えす
            acceptExtension[i] = "*." + acceptExtension[i]; //配列に[*.]を追加する
        }
        return acceptExtension.join(";");   //;を配列に追加する　Windows用
    }
    return function (F) {
        var re = RegExp("\\.(" + acceptExtension.join("|") + ")$", "i");//文字置換
        return (F instanceof Folder || re.test(F.fsName));//フォルダも選択できるようにする
    };
}
//拡張子の選択　Windows　MAC　両方対応　ここまで

//拡張子の判定　ここから
function ext(){
    if(radio_01.value === true){
        var ext = '.ai';
     }else{
        var ext = '.pdf';
     };
    return ext;
};
//拡張子の判定　ここまで

win.center();//ウインドウパネル　センター表示
win.show();//ウインドウパネル　実行